// file      : CCF/IDL2/SemanticAction/Factory.hpp
// author    : Boris Kolpackov <boris@dre.vanderbilt.edu>
// cvs-id    : Factory.hpp,v 1.3 2003/08/28 17:39:04 boris Exp

#ifndef CCF_IDL2_SEMANTIC_ACTION_FACTORY_HPP
#define CCF_IDL2_SEMANTIC_ACTION_FACTORY_HPP

namespace CCF
{
  namespace IDL2
  {
    namespace SemanticAction
    {
      class Include;
      class Module;
      class Interface;
      class Attribute;
      class Operation;
      class TypeId;
      class TypePrefix;

      //
      //
      //
      class Factory
      {
      public:
        virtual
        ~Factory () throw () {}

        virtual Include&
        include () = 0;

        virtual TypeId&
        type_id () = 0;

        virtual TypePrefix&
        type_prefix () = 0;

        virtual Module&
        module () = 0;

        virtual Interface&
        interface () = 0;

        virtual Attribute&
        attribute () = 0;

        virtual Operation&
        operation () = 0;
      };

    }
  }
}

#endif  // CCF_IDL2_SEMANTIC_ACTION_FACTORY_HPP
